package com.xmlcalabash.drivers;

import net.sf.saxon.s9api.Processor;
import net.sf.saxon.s9api.QName;
import net.sf.saxon.s9api.SaxonApiException;
import net.sf.saxon.s9api.SaxonApiUncheckedException;
import net.sf.saxon.s9api.XPathCompiler;
import net.sf.saxon.s9api.XPathExecutable;
import net.sf.saxon.s9api.XPathSelector;
import net.sf.saxon.s9api.XdmAtomicValue;
import net.sf.saxon.s9api.XdmItem;
import net.sf.saxon.s9api.XdmNode;

import java.io.IOException;
import java.net.URISyntaxException;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Vector;

public class SaxonTest {
    public static void main(String[] args) throws SaxonApiException, IOException, URISyntaxException {
        SaxonTest main = new SaxonTest();
        main.run(args);
    }

    public void run(String[] args) throws SaxonApiException, IOException, URISyntaxException {
        Vector<XdmItem> results = evaluateXPath("boolean(string-length($href) > 0)");
        System.err.println(results.get(0));
    }

    protected Vector<XdmItem> evaluateXPath(String xpath) throws SaxonApiException {
        Processor processor = new Processor(false);
        Hashtable<String,String> nsBindings = new Hashtable<String, String> ();
        Hashtable<QName,String> globals = new Hashtable<QName, String> ();

        globals.put(new QName("", "href"), "test");

        XdmNode doc = null;
        Vector<XdmItem> results = new Vector<XdmItem> ();

        XPathCompiler xcomp = processor.newXPathCompiler();

        for (QName varname : globals.keySet()) {
            xcomp.declareVariable(varname);
        }

        for (String prefix : nsBindings.keySet()) {
            xcomp.declareNamespace(prefix, nsBindings.get(prefix));
        }
        XPathExecutable xexec = xcomp.compile(xpath);
        XPathSelector selector = xexec.load();

        for (QName varname : globals.keySet()) {
            XdmAtomicValue value = new XdmAtomicValue("irrelevant");
            selector.setVariable(varname,value);
        }

        if (doc != null) {
            selector.setContextItem(doc);
        }

        try {
            Iterator<XdmItem> values = selector.iterator();
            while (values.hasNext()) {
                results.add(values.next());
            }
        } catch (SaxonApiUncheckedException saue) {
            throw saue;
        }

        return results;
    }
}
